Introduction
Options
Command line usage
PHP Manual

## Differences to other SAPIs

Remarkable differences of the CLI SAPI compared to other SAPIs:

- Unlike the CGI SAPI, no headers are written to the output.

  Though the CGI SAPI provides a way to suppress HTTP headers, there's no equivalent switch to enable them in the CLI SAPI.

  CLI is started up in quiet mode by default, though the -q and --no-header switches are kept for compatibility so that you can use older CGI scripts.

  It does not change the working directory to that of the script. (-C and --no-chdir switches kept for compatibility)

  Plain text error messages (no HTML formatting).

- There are certain php.ini directives which are overridden by the CLI SAPI because they do not make sense in shell environments:

  Overridden php.ini directives
  Directive | CLI SAPI default value | Comment
  --- | --- | ---
  html_errors | `FALSE` | It can be quite hard to read the error message in your shell when it's cluttered with all those meaningless HTML tags, therefore this directive defaults to `FALSE`.
  implicit_flush | `TRUE` | It is desired that any output coming from print(), echo() and friends is immediately written to the output and not cached in any buffer. You still can use output buffering if you want to defer or manipulate standard output.
  max_execution_time | 0 (unlimited) | Due to endless possibilities of using PHP in shell environments, the maximum execution time has been set to unlimited. Whereas applications written for the web are often executed very quickly, shell application tend to have a much longer execution time.
  register_argc_argv | `TRUE` | Because this setting is `TRUE` you will always have access to argc (number of arguments passed to the application) and argv (array of the actual arguments) in the CLI SAPI. The PHP variables $argc and $argv are registered and filled in with the appropriate values when using the CLI SAPI. You can also go through $_SERVER or. Example: $_SERVER['argv']
  output_buffering | `FALSE` | Altough the php.ini setting is hardcoded to `FALSE` the Output buffering functions are available.
  max_input_time | `FALSE` | The PHP CLI doesn't not support GET, POST or file uploads.

  > Note: These directives cannot be initialized with another value from the configuration file php.ini or a custom one (if specified). This is a limitation because those default values are applied after all configuration files have been parsed. However, their value can be changed during runtime (which does not make sense for all of those directives, e.g. register_argc_argv).

  > Note: It is recommended to set ignore_user_abort for command line scripts. See ignore_user_abort() for more info.

- To ease working in the shell environment, a number of constants are defined for I/O streams .

- The CLI SAPI does not change the current directory to the directory of the executed script!

  Example #1 Example showing the difference to the CGI SAPI:

  `<?php
  // Our simple test application named test.php
  echo getcwd(), "\n";
  ?>`

  When using the CGI version, the output is:

      $ pwd
      /tmp

      $ php -q another_directory/test.php
      /tmp/another_directory

  This clearly shows that PHP changes its current directory to the one of the executed script.

  Using the CLI SAPI yields:

      $ pwd
      /tmp

      $ php -f another_directory/test.php
      /tmp

  This allows greater flexibility when writing shell tools in PHP.

  > Note: The CGI SAPI supports this CLI SAPI behaviour by means of the -C switch when run from the command line.

Introduction
Options
Command line usage
PHP Manual